"use strict";
// incremental search. based by peco.
var child_process = require('child_process');
var which = require("which");
function exec(suggestions, defaultQueries, command) {
    "use strict";
    if (command === void 0) { command = "peco"; }
    return new Promise(function (resolve, reject) {
        // EPIPE is can't handling. resolve command exists first.
        which(command, function (err, path) {
            if (!!err) {
                reject(err);
                return;
            }
            resolve(path);
        });
    })
        .then(function (path) {
        return new Promise(function (resolve, reject) {
            var args = [];
            if (defaultQueries && 0 < defaultQueries.length) {
                args = ["--query", defaultQueries.join(" ")];
            }
            var cmd = child_process.spawn(path, args);
            var result = [];
            cmd.on("error", function (err) {
                reject(err);
            });
            cmd.stdout.on("data", function (data) {
                var str = data.toString();
                var newResult = str.split("\n").filter(function (str) { return !!str; });
                result = result.concat(newResult);
            });
            cmd.stdout.on("end", function () {
                resolve(result);
            });
            cmd.stdin.write(suggestions.join('\n') + "\n");
        });
    });
}
exports.exec = exec;
//# sourceMappingURL=incrementalsearch.js.map