"use strict";
var Insight = require("insight");
var pkg = require("../package.json");
var Tracker = (function () {
    function Tracker() {
        this.insight = new Insight({
            // Google Analytics tracking code
            trackingCode: "UA-6628015-5",
            packageName: pkg.name,
            packageVersion: pkg.version
        });
    }
    Object.defineProperty(Tracker.prototype, "optOut", {
        get: function () {
            return this.insight.optOut;
        },
        set: function (val) {
            this.insight.config.set('optOut', val);
        },
        enumerable: true,
        configurable: true
    });
    Tracker.prototype.askPermissionIfNeeded = function () {
        var _this = this;
        if (typeof this.optOut === "undefined") {
            return new Promise(function (resolve, reject) {
                _this.insight.askPermission(null, function () {
                    resolve();
                });
            });
        }
        else {
            return Promise.resolve(null);
        }
    };
    Tracker.prototype.track = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        this.insight.track.apply(this.insight, args);
    };
    return Tracker;
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Tracker;
//# sourceMappingURL=tracker.js.map