"use strict";
function deepClone(obj) {
    "use strict";
    if (obj == null) {
        return obj;
    }
    else if (Array.isArray(obj)) {
        return obj.map(function (obj) { return deepClone(obj); });
    }
    else if (obj instanceof RegExp) {
        return obj;
    }
    else if (typeof obj === "object") {
        var cloned = {};
        Object.keys(obj).forEach(function (key) { return cloned[key] = deepClone(obj[key]); });
        return cloned;
    }
    else {
        return obj;
    }
}
exports.deepClone = deepClone;
function extractDependencies(sourceCode) {
    "use strict";
    var referenceRegExp = /^\/\/\/\s*<reference\s+path\s*=\s*("|')(.+?)\1.*?\/>/;
    return sourceCode
        .split("\n")
        .map(function (line) { return line.match(referenceRegExp); })
        .filter(function (matches) { return !!matches; })
        .map(function (matches) { return matches[2]; });
}
exports.extractDependencies = extractDependencies;
function padString(str, length, pad) {
    "use strict";
    if (pad === void 0) { pad = " "; }
    var shortage = length - str.length;
    for (var i = 0; i < shortage; i++) {
        str += pad;
    }
    return str;
}
exports.padString = padString;
//# sourceMappingURL=utils.js.map